<?php
/**
 * $Id: controller.php 8492 2012-06-15 10:54:05Z alfiya $
 * $LastChangedDate: 2012-06-15 16:54:05 +0600 (Fri, 15 Jun 2012) $
 * $LastChangedBy: alfiya $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('JPATH_BASE') or die('Restricted access');
/*if(!ioncube_check_license_properties())
 {
 JError::raiseWarning(120, "License is not valied");
 JRequest::setVar('controller', 'license');
 }*/
jimport('joomla.application.component.controller');
class JcsController extends JController
{
	function __construct()
	{

		parent::__construct();
		$this->registerTask( 'add', 'edit' );
		$this->registerTask( 'apply', 'save' );
	}
	function support() {
		$this->setRedirect('http://support.mightyextensions.com/en/mighty-membership-subscription-joomla-component.html');
	}
	function display() {


		$this->_path['view'] = array(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jcs'.DS.'views'.DS);

		$document   =& JFactory::getDocument();

		$viewType	  = 'html';

		$viewName	  = JRequest::getCmd( 'view', $this->_name );
		$viewLayout	= JRequest::getCmd( 'layout', 'default' );

		$view = &$this->getView( $viewName, $viewType, '', array( 'base_path'=>JPATH_ADMINISTRATOR.DS.'components'.DS.'com_jcs'));

		if ($model = & $this->getModel($viewName)) {
			$view->setModel($model, true);
		}

		$view->setLayout($viewLayout);
		$view->display();
		//parent::display();
	}
	function edit()
	{
		//JRequest::setVar( 'view', 'weblink' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();

		// Checkin the weblink
		$model = $this->getModel('jcs');
		$model->checkout();
	}
	function publish()
	{
		global $mainframe;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}

		$model = $this->getModel('jcs');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		//echo "dfdgdfgdf"; exit;
		$this->setRedirect( 'index.php?option=com_jcs' );
		//parent::display();
	}


	function unpublish()
	{
		global $mainframe;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to unpublish' ) );
		}

		$model = $this->getModel('jcs');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_jcs' );
		//parent::display();
	}
	function orderup()
	{
		$model = $this->getModel('jcs');
		$model->move(-1);

		$this->setRedirect( 'index.php?option=com_jcs');
	}

	function orderdown()
	{
		$model = $this->getModel('jcs');
		$model->move(1);

		$this->setRedirect( 'index.php?option=com_jcs');
	}

	function saveorder()
	{
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('jcs');
		$model->saveorder($cid, $order);

		$msg = 'New ordering saved';
		$this->setRedirect( 'index.php?option=com_jcs', $msg );
	}
	function save()
	{
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int) $cid[0];
		$db = & JFactory::getDBO();

		$sql = "SELECT * FROM #__jcs_plans WHERE id = ".$post['id'];
		$db->setQuery( $sql );
		$plan = $db->loadObject();

		$model = $this->getModel('jcs');

		$dispatcher =& JDispatcher::getInstance();
		JPluginHelper::importPlugin('system');
		$dispatcher->trigger('onAfterStoreSubscription',array( &$plan, &$model ) );

		if($post['days_type'] == 'years' && $post['days'] > 100) 
		$post['days'] = 100;

		//print_r($post); return;
		if(@is_array(@$post['category']))
		{
			$post['category'] = implode(",", $post['category']);
			$post['type_category'] = 1;
		}
		if(@is_array($post['jsc_category']))
		{
			$post['contentcategory'] = implode(",", $post['jsc_category']);
			$post['type_category'] = 1;
		}
		if(@is_array(@$post['component']))
		{
			$post['type_component'] = 1;
			foreach($post['component'] AS $component)
			{
				$param1 = $post['task_'.$component];
				$param2 = $post['value_'.$component];

				$param_adv1 = $post['advtask_'.$component];
				$param_adv2 = $post['advcond_'.$component];
				$param_adv3 = $post['advvalue_'.$component];

				if($param1[0])
				{
					$post['params'][$component.'_task1'] = $param1[0];
					$post['params'][$component.'_val1'] = $param2[0];
				}
				if($param1[1])
				{
					$post['params'][$component.'_task2'] = $param1[1];
					$post['params'][$component.'_val2'] = $param2[1];
				}
				if($param1[2])
				{
					$post['params'][$component.'_task3'] = $param1[2];
					$post['params'][$component.'_val3'] = $param2[2];
				}
				if($param1[3])
				{
					$post['params'][$component.'_task4'] = $param1[3];
					$post['params'][$component.'_val4'] = $param2[3];
				}
				if(defined('JCS_MODE') && JCS_MODE)
				{
					if($param_adv1[0])
					{
						$post['params'][$component.'_advtask1'] = $param_adv1[0];
						$post['params'][$component.'_advcond1'] = $param_adv2[0];
						$post['params'][$component.'_advval1'] = $param_adv3[0];
					}
					if($param_adv1[1])
					{
						$post['params'][$component.'_advtask2'] = $param_adv1[1];
						$post['params'][$component.'_advcond2'] = $param_adv2[1];
						$post['params'][$component.'_advval2'] = $param_adv3[1];
					}
						
				}
			}
			$post['component'] = implode(",", $post['component']);
		}
		$post['params']['calculate_method'] = $post['method'];
		$post['params']['required'] = $post['required'];
		$post['params']['plans_grant'] = $post['grant_plans'];
		$post['params']['show_plans_grant'] = $post['show_grant'];
		$post['params']['karma'] = $post['karma'];
		$post['params']['karma_discount'] = $post['karma_discount'];
		$post['params']['redirect'] = $post['redirect'];
		$post['params']['cl_period'] = $post['cl_period'];
		$post['params']['currency'] = $post['currency'];
		$post['params']['layout_price'] = $post['layout_price'];
		$post['params']['extra_emails'] = $post['extra_emails'];
		$post['params']['date_from'] = $post['date_from'];
		$post['params']['date_to'] = $post['date_to'];
		$post['params']['plans_deactivate'] = $post['plans_deactivate'];
		//$post['params']['deactivate'] = $post['deactivate'];
		$post['params']['ad_ids'] = $post['ad_ids'];
		$post['params']['ad_period'] = $post['ad_period'];
		
		$post['params']['discount_period'] = $post['discount_period'];
		
		$post['params']['muaccess'] = $post['muaccess'];
		if(isset($post['mua_msg_type']))
		{
			$post['params']['mua_msg_type'] = $post['mua_msg_type'];
		}

		if(@is_array(@$post['req_plans']))
		{
			$post['cross_plans'] = implode(",", $post['req_plans']);
		}
			
		
		$post['params']['cp_plans'] = (@is_array(@$post['cp_plans'])) ? implode(",", $post['cp_plans']) : $post['cp_plans'];
		//$post['params']['cross_period'] = $post['cross_period'];
		
		
		if($post['gid'] == 29) $post['gid'] = 0;
		if($post['gid'] == 30) $post['gid'] = 0;

		jimport('joomla.filter.filteroutput');
		$post['description'] = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$post['finish_msg']  = JRequest::getVar( 'finish_msg', '', 'post', 'string', JREQUEST_ALLOWRAW );

		$post['msg_successful'] = JRequest::getVar( 'msg_successful', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$post['msg_fail']  = JRequest::getVar( 'msg_fail', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$post['msg_expiration'] = JRequest::getVar( 'msg_expiration', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$post['params']['send_as'] = JRequest::getVar( 'send_as');

		$post['adwords']  = JRequest::getVar( 'adwords', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$post['description'] = str_replace('<br>', '<br />', $post['description']);
		$post['finish_msg'] = str_replace('<br>', '<br />', $post['finish_msg']);

		$post['alerts']['msg_successful'] = str_replace('<br>', '<br />', $post['msg_successful']);
		$post['alerts']['msg_fail'] = str_replace('<br>', '<br />', $post['msg_fail']);
		$post['alerts']['msg_expiration'] = str_replace('<br>', '<br />', $post['msg_expiration']);
		$post['alerts']['msg_successful_sbj'] = $post['msg_successful_sbj'];
		$post['alerts']['msg_fail_sbj'] = $post['msg_fail_sbj'];
		$post['alerts']['msg_expiration_sbj'] = $post['msg_expiration_sbj'];

		$post['name']	= JFilterOutput::ampReplace($post['name']);
		
		
		$post['auto_child_plans'] = (isset($post['childs']) ? implode(',', $post['childs']) : '');
		$post['params']['auto_child_finish'] = $post['auto_child_finish'];
		$post['params']['auto_activate_in'] = $post['activate_in'];
		$post['params']['auto_activate_in_type'] = $post['activate_in_type'];
		
		$post['params']['alert_user'] = $post['alert_user'];
		$post['params']['purchase_limit'] = $post['purchase_limit'];
			
		
		$query = "SELECT name"
		. "\n FROM #__core_acl_aro_groups"
		. "\n WHERE id = " . (int) $post['gid']
		;
		//echo $query; exit();
		$db->setQuery( $query );
		$usertype = $db->loadResult();
		$post['usertype'] = ($post['gid'] == 0) ? '' : $usertype;

		//echo $post['component'];
		//print_r( $post['params'] );         return;

		if ($model->store($post)) {
			$msg = JText::_( 'Subscription Plan Saved' );
		} else {
			$msg = JText::_( 'Error Saving Plan' );
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$model->checkin();
		
		
		$registry = new JRegistry();
		$registry->loadArray($post['params']);	
		$plugin_params  = $registry->toString();
		$plugin_params = new JParameter($plugin_params);
		JPluginHelper::importPlugin('payment');
		$dispatcher->trigger('onCheckParams', array( $plugin_params ) );
		
		$link = 'index.php?option=com_jcs';
		if(JRequest::getWord('task') == 'apply' || count(JError::getErrors()) )
		$link = 'index.php?option=com_jcs&task=edit&cid[]='.$model->id;
		
		$this->setRedirect($link, $msg);
	}
	
	function remove()
	{
		global $mainframe;

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to delete' ) );
		}

		$model = $this->getModel('jcs');
		if(!$model->delete($cid)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_jcs' );
	}

	function cancel()
	{
		global $mainframe;
		$id = JRequest::getVar('cid');
		$model = $this->getModel('jcs');
		$model->checkin($id[0]);
		$this->setRedirect( 'index.php?option=com_jcs' );
		
	}
	
}
?>
