<?php
/**
 * $Id: default.php 7421 2011-11-02 04:34:25Z alfiya $
 * $LastChangedDate: 2011-11-02 10:34:25 +0600 (Wed, 02 Nov 2011) $
 * $LastChangedBy: alfiya $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access'); ?>
<?php
include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'prepend.php');
?>
<form action="<?php echo $this->request_url; ?>" method="post" name="adminForm" id="adminForm">

<table>
<tr>
	<td align="left" width="100%">
		<?php echo JText::_( 'Filter' ); ?>:
		<input type="text" name="search" id="search" value="<?php echo $this->lists['search'];?>" class="text_area" onchange="document.adminForm.submit();" />
		<button onclick="this.form.submit();"><?php echo JText::_( 'Go' ); ?></button>
		<button onclick="document.getElementById('search').value='';this.form.submit();"><?php echo JText::_( 'Reset' ); ?></button>
	</td>
	<td nowrap="nowrap">
		<?php
			echo $this->lists['type'];
			echo $this->lists['state'];
		?>
	</td>
</tr>
</table>

<TABLE border="0" cellpadding="0" cellspacing="0" class="adminlist">
  <thead>
  <TR>
    <TH width="20"><?php echo JText::_( 'Num' ); ?></TH>
    <TH width="20"><input type="checkbox" id="checkMain" name="toggle" value=""  onclick="checkAll(<?php echo count( $this->rows ); ?>);" /></TH>
    <TH class="title">
        <?php echo JHTML::_('grid.sort', 'Coupon Value', 'value', @$this->lists['order_Dir'], @$this->lists['order'] ); ?></TH>
    <TH width="5%">
        <?php echo JHTML::_('grid.sort', 'Discount', 'discount', @$this->lists['order_Dir'], @$this->lists['order'] ); ?></TH>
    <TH width="5%" nowrap="nowrap">
        <?php echo JHTML::_('grid.sort', 'Use Limit', 'use_num', @$this->lists['order_Dir'], @$this->lists['order']); ?></TH>
    <TH width="5%" nowrap="nowrap">
        <?php echo JHTML::_('grid.sort', 'Used', 'used_num', @$this->lists['order_Dir'], @$this->lists['order']); ?></TH>
    <TH width="7%">
        <?php echo JHTML::_('grid.sort', 'Start', 'ctime', @$this->lists['order_Dir'], @$this->lists['order'] ); ?></TH>
    <TH width="7%">
        <?php echo JHTML::_('grid.sort', 'Finish', 'extime', @$this->lists['order_Dir'], @$this->lists['order']); ?></TH>
    <TH width="5%" nowrap="nowrap">
        <?php echo JHTML::_('grid.sort', 'Published', 'published', @$this->lists['order_Dir'], @$this->lists['order']); ?></TH>
    <TH width="1%" nowrap="nowrap">
        <?php echo JHTML::_('grid.sort', 'Id', 'id', @$this->lists['order_Dir'], @$this->lists['order']); ?></TH>
  </TR>
  </thead>

<?php
$k = 0;
foreach($this->rows AS $i => $row)
{
    $checked 	  = JHTML::_('grid.checkedOut', $row, $i );
    //$published 	= jcHelper::PublishedProcessingX( $row, 'jc_coupons', $i);
    //$name       = jcHelper::ElementName('value', $row, $i, 'Coupon');
    $name       = JHTML::link('index.php?option=com_jcs&controller=coupon&task=edit&cid[]='.$row->id, $row->value);
    $published 	= JHTML::_('grid.published', $row, $i );
    $k          = 1 - $k;
    $start = new JDate($row->start);
    $finish = $row->finish > 0 ? new JDate($row->finish) : false;
    $icon = $row->discount == 'procent' ? 'procent' : 'sum';
    ?>

    <tbody id="row_<?php echo $row->id ?>">
      <TR class="sectiontableentry<?php echo $k + 1; ?>">
        <TD width="1%"><?php echo ($i + 1 ); ?></TD>
        <TD width="1%"><?php echo $checked?></TD>
        <TD><?php echo $name ?></TD>
        <TD align="right" nowrap="nowrap"><?php echo $row->discount ?> <img src="components/com_jcs/images/sidebar/<?php echo $icon; ?>.png" align="absmiddle" alt=""></TD>
        <TD align="right"><span id="row_use_num_<?php echo $row->id?>"><?php echo $row->use_num == 0 ? '<span class="g">'.JText::_('No Limit').'</span>': $row->use_num?></TD>
        <TD align="right"><?php echo $row->use_num && ($row->used_num >= $row->use_num) ? '<span class="r">'.$row->used_num.'</span>': $row->used_num?></TD>
        <TD align="center" nowrap="nowrap"><?php echo $start->toFormat(JCS_DATE_FORMAT);?></TD>
        <TD align="center" nowrap="nowrap"><?php if($row->finish > 0){
          if($row->expire == 1)
          {
            echo '<span class="r">'. $finish->toFormat(JCS_DATE_FORMAT).'</span>';
          }
          else
          {          	
          echo $finish->toFormat(JCS_DATE_FORMAT);
          }
        } else {
          echo '<span class="g">'.JText::_('Never').'</span>';
        }?>
        </TD>
        <TD align="center"><?php echo $published?></TD>
        <TD align="center"><?php echo $row->id; ?></TD>
      </TR>
    </tbody>
    <?php
        //include JPATH_JC_VIEW.DS.'Coupons_row.php';
    }
    ?>

  <tfoot>
  <td colspan="13">
  <?php echo $this->pageNav->getListFooter(); ?>
  </td>
  </tfoot>
</table>

<input type="hidden" name="option" value="<?php echo $option; ?>" />
<input type="hidden" name="controller" value="coupon" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="boxchecked" value="0" />
<input type="hidden" name="hidemainmenu" value="0" />
<input type="hidden" name="filter_order" value="<?php echo $this->lists['order']; ?>" />
<input type="hidden" name="filter_order_Dir" value="" />
</form>
<?php include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'apend.php'); ?>