<?php
/**
 * $Id: default.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access'); ?>
<?php
$user 	=& JFactory::getUser();
$ordering = ($this->lists['order'] == 'a.ordering');
JHTML::_('behavior.tooltip');
include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'prepend.php');
?>
<form action="<?php echo $this->request_url; ?>" method="post" name="adminForm">
<table>
<tr>
	<td align="left" width="100%">
		<?php echo JText::_( 'Filter' ); ?>:
		<input type="text" name="search" id="search" value="<?php echo $this->lists['search'];?>" class="text_area" onchange="document.adminForm.submit();" />
		<button onclick="this.form.submit();"><?php echo JText::_( 'Go' ); ?></button>
		<button onclick="document.getElementById('search').value='';this.form.submit();"><?php echo JText::_( 'Reset' ); ?></button>
	</td>
	<td nowrap="nowrap">
		<?php
			echo $this->lists['catid'];
			echo $this->lists['state'];
		?>
	</td>
</tr>
</table>
<div id="editcell">
	<table class="adminlist">
	<thead>
		<tr>
			<th width="1%">
				<?php echo JText::_( 'NUM' ); ?>
			</th>
			<th width="1%">
				<input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count( $this->items ); ?>);" />
			</th>
			<th width="10%" nowrap="nowrap" colspan="2">
				<?php echo JText::_( 'Period' ); ?>
			</th>
			<th class="title">
				<?php echo JHTML::_('grid.sort',  'Title', 'a.name', $this->lists['order_Dir'], $this->lists['order'] ); ?>
			</th>
			<th width="5%" nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  'Published', 'a.published', $this->lists['order_Dir'], $this->lists['order'] ); ?>
			</th>
			<th width="12%" nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  'Order', 'a.ordering', $this->lists['order_Dir'], $this->lists['order'] ); ?>
			</th>
			<th width="1%" nowrap="nowrap">
				<?php echo JHTML::_('grid.order',  $this->items ); ?>
			</th>
			<th width="15%"  class="title">
				<?php echo JHTML::_('grid.sort',  'Category', 'category', $this->lists['order_Dir'], $this->lists['order'] ); ?>
			</th>
			<th width="1%" nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  'Price', 'a.price', $this->lists['order_Dir'], $this->lists['order'] ); ?>
			</th>
			<th width="1%" nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  'ID', 'a.id', $this->lists['order_Dir'], $this->lists['order'] ); ?>
			</th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="11">
				<?php echo $this->pagination->getListFooter(); ?>
			</td>
		</tr>
	</tfoot>
	<tbody>
	<?php
	$k = 0;
	for ($i=0, $n=count( $this->items ); $i < $n; $i++)
	{
		$row = &$this->items[$i];

		$link 	= JRoute::_( 'index.php?option=com_jcs&controller=jcs&task=edit&cid[]='. $row->id );

		$checked 	= JHTML::_('grid.checkedout',   $row, $i );
		$published 	= JHTML::_('grid.published', $row, $i );

		$row->cat_link 	= JRoute::_( 'index.php?option=com_categories&section=com_jcs&task=edit&type=other&cid[]='. $row->catid );
		?>
		<tr class="<?php echo "row$k"; ?>">
			<td>
				<?php echo $this->pagination->getRowOffset( $i ); ?>
			</td>
			<td>
				<?php echo $checked; ?>
			</td>			
			<?php if($row->days >= 100 && $row->days_type == 'years'){ ?>
			<td></td>
			<td>
				<?php echo JText::_("Lifetime");?>
			</td>
			<?php } else { ?> 
			<td align="right">
				<?php echo $row->days;?>
			</td>
			<td>
				<?php echo JText::_($row->days_type);?>
			</td>
			<?php } ?>
			
			<td>
				<?php
				if (  JTable::isCheckedOut($this->user->get ('id'), $row->checked_out ) ) {
					echo $row->name;
				} else {
				?>
					<a href="<?php echo $link; ?>" title="<?php echo JText::_( 'Edit' ); ?>">
						<?php echo $row->name; ?></a><BR> <?php echo JText::_('Type of subscription plan is') ?>:
						<span style="color:green"><?php
				}
        unset($t);
        if($row->type_category) $t[] = JText::_('Category');
        if($row->type_component) $t[] = JText::_('Component');
        if($row->type_user) $t[] = JText::_('User');
        if($row->type_article) $t[] = JText::_('Article');
        echo @implode(", ", $t);
       ?></span>, <?php echo JText::_('Subscriptions') ?>: 
       ( <b style="color: black;" class="hasTip" title="<?php echo $row->numofsub.'::'.JText::_('Subscriptions amount') ?>"><?php echo $row->numofsub;?></b> / 
       	 <b style="color: green;" class="hasTip" title="<?php echo $row->sub_published.'::'.JText::_('Subscriptions published') ?>"><?php echo $row->sub_published;?></b> /
       	 <b style="color: maroon;" class="hasTip" title="<?php echo $row->sub_unpublished.'::'.JText::_('Subscriptions unpublished') ?>"><?php echo $row->sub_unpublished;?></b> /
       	 <b style="color: grey;" class="hasTip" title="<?php echo $row->sub_expired.'::'.JText::_('Subscriptions expired') ?>"><?php echo $row->sub_expired;?></b>	)
			</td>
			<td align="center">
				<?php echo $published;?>
			</td>
			<td class="order" colspan="2">
				<span><?php echo $this->pagination->orderUpIcon( $i, ($row->catid == @$this->items[$i-1]->catid),'orderup', 'Move Up', $ordering ); ?></span>
				<span><?php echo $this->pagination->orderDownIcon( $i, $n, ($row->catid == @$this->items[$i+1]->catid), 'orderdown', 'Move Down', $ordering ); ?></span>
				<?php $disabled = $ordering ?  '' : 'disabled="disabled"'; ?>
				<input type="text" name="order[]" size="5" value="<?php echo $row->ordering;?>" <?php echo $disabled ?> class="text_area" style="text-align: center" />
			</td>
			<td>
				<a href="<?php echo $row->cat_link; ?>" title="<?php echo JText::_( 'Edit Category' ); ?>">
				<?php echo $row->cat; ?>
				</a>
			</td>
			<td align="center">
				<?php echo $row->price; ?>
			</td>
			<td align="center">
				<?php echo $row->id; ?>
			</td>
		</tr>
		<?php
		$k = 1 - $k;
	}
	?>
	</tbody>
	</table>
</div>

<input type="hidden" name="option" value="com_jcs" />
<input type="hidden" name="controller" value="jcs" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="boxchecked" value="0" />
<input type="hidden" name="filter_order" value="<?php echo $this->lists['order']; ?>" />
<input type="hidden" name="filter_order_Dir" value="" />
</form>

<?php include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'apend.php'); ?>