<?php
/**
 * $Id: default.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access'); ?>
<?php
$user 	=& JFactory::getUser();
$ordering = ($this->lists['order'] == 'a.ordering');
JHTML::_('behavior.tooltip');

if( !JRequest::getVar('no_html', 0 )){
  include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'prepend.php');
?>

<form action="<?php echo $this->request_url; ?>" method="post" name="adminForm">

<table>
<tr>
	<td align="left" width="100%">
		<?php echo JText::_( 'Filter' ); ?>:
		<input type="text" name="search" id="search" value="<?php echo $this->lists['search'];?>" class="text_area" onchange="document.adminForm.submit();" />
		<button onclick="this.form.submit();"><?php echo JText::_( 'Go' ); ?></button>
		<button onclick="document.getElementById('search').value='';this.form.submit();"><?php echo JText::_( 'Reset' ); ?></button>
	</td>
	<td nowrap="nowrap">
		<?php
			echo $this->lists['plan'];
			echo $this->lists['state'];
		?>
	</td>
</tr>
</table>
<?php } ?>

<div id="editcell">
	<table class="adminlist">
	<thead>
		<tr>
			<th width="1%">
				<?php echo JText::_( 'NUM' ); ?>
			</th>
			<th width="1%">
				<input type="checkbox" name="toggle" value="" onclick="checkAll(<?php echo count( $this->items ); ?>);" />
			</th>
			<th class="title">
			  <?php
			  if( !JRequest::getVar('no_html', 0 )){
				  echo JHTML::_('grid.sort',  'Subscription', 'p.name', $this->lists['order_Dir'], $this->lists['order'] );
			  } else{ echo JText::_('Subscription'); }?>
			</th>
			<th width="1%" nowrap="nowrap"><?php echo JText::_('Coupon Discount'); ?></th>
			<th width="1%">
				<?php
			  if( !JRequest::getVar('no_html', 0 )){
			    echo JHTML::_('grid.sort',  'Published', 'up.published', $this->lists['order_Dir'], $this->lists['order'] );
        } else{ echo JText::_('Published'); }?>
			</th>
			<th width="1%" nowrap="nowrap">
				<?php
			  if( !JRequest::getVar('no_html', 0 )){
			    echo JHTML::_('grid.sort',  'Gateway', 'up.gateway', $this->lists['order_Dir'], $this->lists['order'] );
				} else{ echo JText::_('Gateway'); }?>
			</th>
			<th width="1%">
				<?php
			  if( !JRequest::getVar('no_html', 0 )){
			    echo JHTML::_('grid.sort',  'Days Left', 'days', $this->lists['order_Dir'], $this->lists['order'] );
				} else{ echo JText::_('Days Left'); }?>
			</th>
			<th width="1%">
				<?php
			  if( !JRequest::getVar('no_html', 0 )){
			    echo JHTML::_('grid.sort',  'Count', 'up.access_count', $this->lists['order_Dir'], $this->lists['order'] );
				} else{ echo JText::_('Count'); }?>
			</th>
			<th width="1%">
				<?php
			  if( !JRequest::getVar('no_html', 0 )){
			    echo JHTML::_('grid.sort',  'Limit', 'up.access_limit', $this->lists['order_Dir'], $this->lists['order'] );
				} else{ echo JText::_('Limit'); }?>
			</th>
			<th width="1%">
				<?php
			  if( !JRequest::getVar('no_html', 0 )){
			    echo JHTML::_('grid.sort',  'Created', 'up.created', $this->lists['order_Dir'], $this->lists['order'] );
				} else{ echo JText::_('Created'); }?>
			</th>
			<th width="1%">
				<?php
			  if( !JRequest::getVar('no_html', 0 )){
			    echo JHTML::_('grid.sort',  'Period', 'ctime', $this->lists['order_Dir'], $this->lists['order'] );
				} else{ echo JText::_('Period'); }?>
			</th>
			<th width="1%" nowrap="nowrap">
				<?php
			  if( !JRequest::getVar('no_html', 0 )){
			    echo JHTML::_('grid.sort',  'Price', 'up.price', $this->lists['order_Dir'], $this->lists['order'] );
				} else{ echo JText::_('Price'); }?>
			</th>
			<th width="1%" nowrap="nowrap">
				<?php
			  if( !JRequest::getVar('no_html', 0 )){
			    echo JHTML::_('grid.sort',  'ID', 'up.id', $this->lists['order_Dir'], $this->lists['order'] );
				} else{ echo JText::_('ID'); }?>
			</th>
		</tr>
	</thead>
	<?php
	if( !JRequest::getVar('no_html', 0 )){
	?>
	<tfoot>
		<tr>
			<td colspan="15">
				<?php echo $this->pagination->getListFooter(); ?>
			</td>
		</tr>
	</tfoot>
	<?php } ?>
	<tbody>
	<?php
	$k = 0;
	for ($i=0, $n=count( $this->items ); $i < $n; $i++)
	{
		$row = &$this->items[$i];
		$params = new JParameter($row->params);

		$link 	= JRoute::_( 'index.php?option=com_jcs&controller=users&task=edit&cid[]='. $row->id );
		$checked 	= JHTML::_('grid.checkedout',   $row, $i );
		
		if( !JRequest::getVar('no_html', 0 )){
		  $published = JHTML::_('grid.published', $row, $i );
		} else {
		  $published  = '<div id="jcs_published_div_'.$row->id.'">';
		  $published .= '<a href="javascript: void(0);" onclick = "juJcsPublished('.$row->id.', '.($row->published ? '0' : '1' ).')">';
		  $published .= '<img id="jcs_published_img_'.$row->id.'" src = "images/'.( $row->published ? 'tick.png' : 'publish_x.png' ).'">';
      $published .= '</a>';
      $published .= '</div>';
		}
   ?>
		<tr class="<?php echo "row$k"; ?>">
			<td>
				<?php echo $this->pagination->getRowOffset( $i ); ?>
			</td>			
			<td>
				<?php echo $checked; ?>
			</td>
			<td>
				<a href="<?php echo $link; ?>" title="<?php echo JText::_( 'Edit Plan' ); ?>">
				<?php echo $row->name; ?>
				</a><br>
				User: <b style="color:green"><?php echo $row->uname; ?></b>, 
				User Email: <a href="mailto:<?php echo $row->email; ?>"><?php echo $row->email; ?></a>, 
				User ID: <span style="color:maroon">
					<a href="<?php echo $this->edit_profile_link.$row->uid; ?>" target="_blank"><?php echo $row->uid; ?></a>
					</span>
			</td>
			
			<td>
				<?php if($coupon = $row->coupon_info) 
				{ 
					$cdiscount = ($coupon->discount_type == 'sum' ? $coupon->price - $coupon->discount : round($coupon->price * $coupon->discount / 100, 2 ));
					if($cdiscount < 0 ) $cdiscount = $coupon->price;
					echo JText::_('Coupon').': '.$coupon->value.' ['.$coupon->id.']';
					echo '<br>'.JText::_('Saved').': '.str_replace(array("00", "Sign"), array($cdiscount, $params->get('currency')), $params->get('layout_price'));
					/*	.'<img src="components/com_jcs/images/sidebar/'.$coupon->discount_type.'.png" align="absmiddle" alt="">';	*/	
				}
				?>
			</td>
			
			<td align="center">
				<?php echo $published; ?>
			</td>
			<td>
				<?php echo $row->gateway;?><br>
				<?php echo $row->gateway_id;?>
			</td>
			<td align="right">
				<?php echo $row->days;?>
			</td>
			<td>
				<?php echo $row->access_count;?>
			</td>
			<td>
				<?php echo $row->access_limit;?>
			</td>
			<td nowrap>
				<?php $created = new JDate($row->created); echo $created->toFormat(JCS_DATE_FORMAT);?>
			</td>
			<td nowrap>
				<?php if($row->days_enable < 36500 ) {
					$ctime = new JDate($row->ctime); echo $ctime->toFormat(JCS_DATE_FORMAT);?><br>
				<?php 
					$extime = new JDate($row->extime); echo $extime->toFormat(JCS_DATE_FORMAT);
					}
					else
					echo JText::_('Lifetime');	?>
			</td>
			<td align="right">
				<?php echo $row->price; ?>
			</td>
			<td align="center">
				<?php echo $row->id; ?>
			</td>
		</tr>
		<?php
		$k = 1 - $k;
	}
	?>
	</tbody>
	</table>
</div>
<?php
if( !JRequest::getVar('no_html', 0 )){
?>

<input type="hidden" name="option" value="com_jcs" />
<input type="hidden" name="controller" value="users" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="boxchecked" value="0" />
<input type="hidden" name="filter_order" value="<?php echo $this->lists['order']; ?>" />
<input type="hidden" name="filter_order_Dir" value="" />
</form>

<?php
  include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'views'.DS.'apend.php'); 
}
?>