<?php
/**
 * $Id: controller.php 8493 2012-06-15 10:54:43Z alfiya $
 * $LastChangedDate: 2012-06-15 16:54:43 +0600 (Fri, 15 Jun 2012) $
 * $LastChangedBy: alfiya $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');

jimport('joomla.application.component.controller');

class JcsController extends JController
{
	var $couponExists = false;
	var $couponValid = false;
	var $couponError = '';

	function display()
	{

		$user =& JFactory::getUser();
		//echo
		if(!$user->get('id'))
		{
			$menus	= &JSite::getMenu();
			$menu	= $menus->setActive(JRequest::getInt('Itemid'));
			$menu	= $menus->getActive();
			if(is_object($menu))
			{
				$params = new JParameter( $menu->params );
				$template = $params->get('form_tmpl', 'standard');
			}
		}
		else
		$template = 'standard';
		if(!$user->get('id') && $template != 'select')
		{
			JRequest::setVar('layout', 'form' );
		}

		parent::display();
	}
	
	function pay()
	{
		global $mainframe;

		$sid = JRequest::getInt('subscr_id');
		$db  = & JFactory::getDBO();
		$user = & JFactory::getUser();
		$url = 'index.php?option=com_jcs&view=jcs&layout=form&Itemid='.JRequest::getInt('Itemid');
		
		/*if(!$user->id)
		{
		    $mainframe->enqueueMessage(JText::_('Please login to continue'), 'Error');
			$this->setRedirect($url);
			return;
		}*/
		$coupon = JRequest::getVar('coupon');


		$dispatcher =& JDispatcher::getInstance();

		$model = $this->getModel('jcs');
		if(!$sid)
		{
			$msg = JText::_( 'You can not purchase this subscription' );
			$mainframe->enqueueMessage($msg, 'Error');
			$this->setRedirect($url);
			return;
		}
		$sql = "SELECT id, days, discount, price, name, params, days_type,
		days, cross_plans, alert_admin
		FROM #__jcs_plans WHERE id = $sid";
		$db->setQuery( $sql );
		$rows = $db->loadObjectList();
		$plan = $rows[0];
		$alert = '';
		$plan_param = new JParameter($plan->params);

		if($plan->cross_plans != '')
		{
			$plan->price = $model->calculatePrice($sid, $plan->cross_plans, $plan->price, $plan->params);
			$alert = $model->getAlert($sid, $plan->cross_plans, $plan->params );

		}
		if($plan_param->get('cp_plans'))
		$params['ctime'] = $model->getCrossPeriod($sid, $plan_param->get('cp_plans'), $user->id);

		$params['order_amount'] = $plan->price;


		if($plan->discount > 0)
		{
			$sql = "SELECT count(*)  FROM #__jcs_user_subscr WHERE subscription_id = $sid AND user_id = ".$user->get('id');
			$db->setQuery( $sql );
			$subscr = $db->loadResult();
			if($subscr > 0 )
			{
				if($disc_period = $plan_param->get('discount_period', 0))
				{
					$sql = "SELECT IF( (TO_DAYS( NOW() ) - TO_DAYS(extime)) < $disc_period, 1, 0 ) as count_discount
					FROM #__jcs_user_subscr  WHERE subscription_id = '$sid' AND user_id = '".$user->get('id')."'
					ORDER BY extime DESC LIMIT 1";
					$db->setQuery( $sql );
					if($count_discount = $db->loadResult())
					{
						$params['order_amount'] = round(($params['order_amount'] - ($params['order_amount'] * ($plan->discount / 100))), 2); // (1 + ($row->discount / 100));

						//$params['a3'] = round(($params['order_amount'] - ($params['order_amount'] * ($plan->discount / 100))), 2);

						$params['a1'] = $plan->price;
						$params['a3'] = round(($params['order_amount'] - ($params['order_amount'] * ($plan->discount / 100))), 2);
					}
				}
			}
		}

		if($karma_discount = $plan_param->get('karma_discount'))
		{
			$API = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php';
			if(file_exists($API))
			{
				$klist = explode("\n", $karma_discount);
				require_once $API;
				if(class_exists('JSCommunityApi')) $capi = new JSCommunityApi(); else $capi = new stdClass();
				if(method_exists($capi, 'getUserCarma')) $karma = $capi->getUserCarma($user->id);
				if($karma->title)
				{
					foreach($klist as $val)
					{

						if($val != '' && strstr($val, $karma->title))
						{
							$kdiscount = explode('::', $val);
							if(isset($kdiscount[1]) && $kdiscount[1] != '')
							{
								$params['order_amount'] = round(($plan->price - ($plan->price * ($kdiscount[1] / 100))), 2);
								//$params['a1'] = $plan->price;
								$params['a3'] = round(($plan->price - ($plan->price * ($kdiscount[1] / 100))), 2);
							}
						}
					}
				}
			}
		}


		$params['processor']    = JRequest::getVar('processor');
		$params['order_id']     = $sid;
		$params['order_title']  = $mainframe->getCfg('sitename').' :: '.$plan->name;
		$params['order_quantity'] = 1;
		$params['user_id'] = $user->get('id');
		$params['task']   = 'create';
		$params['view']   = 'jcs';
		$params['layout'] = 'history';
		$params['option'] = 'com_jcs';
		$params['params'] = $plan->params;
		$params['days_type'] = $plan->days_type;
		$params['days'] = $plan->days;
		$params['prod_id'] =  $params['order_id'];
		$params['Itemid'] =  JRequest::getInt('Itemid');
		$params['currency'] = $plan_param->get('currency');

		$is_mua = false;

		if(substr($coupon, 0, 3) == "MUA")
		{
			$mua = explode("-", $coupon);
			$sql = "SELECT * FROM #__jcs_user_subscr WHERE user_id = '{$user->id}' AND parent='{$mua[1]}'";
			$db->setQuery($sql);
			$user_sub = $db->LoadObject();
			if($user_sub)
			{
				JError::raiseNotice(100, JText::_('You have already used this coupon to get the subscription'));
				parent::display();
				return;
			}
			if(!$user_sub)
			{

				$result = $model->getUserSubscrInfo($mua[1]);

				if(time() > strtotime($result->extime))
				{
					JError::raiseNotice(100, JText::_('Parent subscription has expired'));
					parent::display();
					return;
				}
				if($sid == $result->plan_id)
				{
					$code = md5($result->user_id . $sid . $mua[1] . $result->ctime);
					$code = strtoupper(substr( $code , 0 , 10));
					$mua_params = new JParameter($result->params);
					$mua_subscr = $model->getSubscrMUA($mua[1]);
					if($code == $mua[2] && count($mua_subscr) < $mua_params->get('muaccess'))
					{
						$coupon = false;
						$params['order_amount'] = 0;
						$is_mua = true;
					}
				}
			}
		}
		$coupon_data = new stdClass();
		$coupon_data->id = '';

		if($coupon && ($params['order_amount'] > 0))
		{
			$this->initCoupon($coupon);
			if(!$this->couponExists)
			{
				JError::raiseNotice(100, JText::_('Coupon or Gift Certificate number do not exists'));
				parent::display();
				return;
			}
			else
			{
				if(!$this->couponValid)
				{
					JError::raiseNotice(100, JText::_('Coupon or Gift Certificate is not valid'));
					JError::raiseNotice(100, JText::_($this->couponError));
					parent::display();
					return;
				}
				else
				{
					$coupon_data = $this->applyCoupon($coupon, $params['order_amount']);
					$params['order_amount'] = $coupon_data->out;
					//$params['a1'] = $plan->price;
					$params['a3'] = $coupon_data->out;
				}
			}
		}
		if($coupon_data->id != '')
		$params['order_id'] .= '::'.$coupon_data->id;

		//print_r($params); exit;

		if($params['order_amount'] <= 0)
		{
			$res['sid'] = $sid;
			$res['gateway'] = '.zero-price';
			$res['gateway_id'] = time();
			$res['user_id'] = $user->get('id');
			$res['pay'] = 'success';
			$res['price'] = '0.00';

			if($is_mua)
			{
				$res['gateway'] = '.multi_user_access';
				$res['pay'] = 'mua';
				$res['parent'] = $mua[1];
				$res['extime'] = $result->extime;
			}

			JRequest::setVar('data', $res);

			if($alert == '')
			{
			    if(!$sid || !$res['gateway'] || !$res['gateway_id']
					|| !$res['user_id'] || !array_key_exists('price', $res) || !$res['pay'])
					{
						$link = JRoute::_('index.php?option=com_jcs&view=jcs&layout=form&Itemid='.(JCS_IID_PLANS != '' ? JCS_IID_PLANS : JRequest::getInt('Itemid')), false);

						$msg = JText::_('Not all information is passed to create subscription');
						$mainframe->enqueueMessage($msg, 'Error');
						$this->setRedirect($url);
						return;
					}
					
				if ($model->store($res)) {
					$msg = JText::_( 'Your Subscription Created Successfully' );

					// creating grant plans
					$model->grantPlans($res);

					$model->deactivatePlans($res['sid'], $res);

					if($coupon_data->id && $coupon_data->id != '')
					{
						$sql = "UPDATE #__jcs_coupons_history SET subscription_id = '{$model->subscription_id}' WHERE id = '{$coupon_data->id}'";
						$db->setQuery($sql);
						$db->query();
					}

					JPluginHelper::importPlugin('system');
					$dispatcher->trigger('onAfterStoreFreeSubscription',array( &$plan, &$model ) );

					jcsHelper::alertUser($res, $plan->alert_admin);


				} else {
					JError::raiseError(503, JText::_('Could not save subscription'));
				}
			}
			else
			{
				$msg = JText::_( 'You can not purchase this subscription' );
			}
			$url = ($plan_param->get('redirect')) ? $plan_param->get('redirect') : 'index.php?option=com_jcs&view=jcs&layout=history&plan='.$res['sid'].'&Itemid='.JCS_HISTORY;
			$mainframe->enqueueMessage($msg, ($alert == '') ?  '' :'Error');
			$this->setRedirect($url);

			return;
		}
		if($alert != '')
		{
			$msg = JText::_( 'You can not purchase the subscription' );
			$url = 'index.php?option=com_jcs&view=jcs&layout=form&Itemid='.JRequest::getInt('Itemid');

			//$url = 'index.php?option=com_jcs&view=jcs&layout=history&plan='.$res['sid'].'&Itemid='.JCS_HISTORY;
			$mainframe->enqueueMessage($msg, 'Error');
			$this->setRedirect($url);

			return;
		}

		//echo $params['order_amount'];
		JPluginHelper::importPlugin('payment');
		$dispatcher->trigger('onSendPayment', array (& $params));
		parent::display();
	}

	function applyCoupon($coupon, $price)
	{
		$db = & JFactory::getDBO();
		$user = & JFactory::getUser();

		$sql = "UPDATE #__jcs_coupons SET used_num = used_num + 1 WHERE `value` = '".addslashes($coupon)."'";
		$db->setQuery($sql);
		$db->query();

		$sql = "SELECT * FROM #__jcs_coupons WHERE `value` = '".addslashes($coupon)."'";
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		$row = $rows[0];
		$sid = JRequest::getInt('subscr_id');

		//$price = JRequest::getVar('price'.$sid);

		$sql = "INSERT INTO #__jcs_coupons_history
		(`id` ,	`user_id` ,	`coupon_id` ,	`ctime` ,	`plan_id` ,	`price` , `discount` , `discount_type`, `subscription_id` )
			VALUES (NULL, '".$user->get('id')."', '{$row->id}', NOW(), '$sid', '$price', '{$row->discount}', '{$row->discount_type}', '')";
		$db->setQuery($sql);
		$db->query();
		$res = new stdClass();
		$res->id = $db->insertid();

		if($row->discount_type == 'procent')
		{
			$out = $price - ($price * ($row->discount / 100));
			$out = round($out, 2);
			$res->out = $out;
			return $res;
		}
		else
		{
			if($row->discount_type == 'sum')
			{
				$new = round(($row->discount - $price), 2);
				if($new < 0) $new = 0;
				$sql = "UPDATE #__jcs_coupons SET discount = '{$new}' WHERE `value` = '".addslashes($coupon)."'";
				$db->setQuery($sql);
				$db->query();
			}

			$out = $price - $row->discount;
			if($out < 0) $out = 0;
			$out = round($out, 2);
			$res->out = $out;
			return $res;
		}
	}

	function initCoupon($coupon)
	{
		$db = & JFactory::getDBO();

		$sql = "SELECT *,  IF( extime > NOW() or YEAR(extime) =  0 , 0, 1)  as expired FROM #__jcs_coupons WHERE `value` = '".addslashes($coupon)."' AND `published` = 1 AND `ctime` <= NOW()" ;
		$db->setQuery($sql);
		if($rows = $db->loadObjectList())
		{
			$row = $rows ? $rows[0] : false;

			$this->couponValid =  true;

			if ($row->value) {
				$this->couponExists = true;
			}
			else
			{
				$this->couponExists = false;
			}

			if(($row->use_num > 0) && ($row->used_num >= $row->use_num))
			{
				$this->couponValid =  false;
				$this->couponError = 'Coupon used out';
			}

			if(($row->discount_type == 'sum') && ($row->discount <= 0))
			{
				$this->couponValid =  false;
				$this->couponError = 'Coupon used out';
			}

			if($row->expired)
			{
				$this->couponValid =  false;
				$this->couponError = 'Coupon expired';
			}

			if($row->user_ids)
			{
				$user = JFactory::getUser();
				$ids = explode(",", $row->user_ids);
				if(!in_array($user->get('id'), $ids))
				{
					$this->couponValid =  false;
					$this->couponError = 'You are not allowed to use this coupon';
				}
			}
			if($row->plan_ids)
			{
				$ids = explode(",", $row->plan_ids);
				$sid = JRequest::getInt('subscr_id');
				if(!in_array($sid, $ids))
				{
					$this->couponValid =  false;
					$this->couponError = 'This coupon is not valid for this subscription plan';
				}
			}
			if($row->use_user > 0)
			{
				$user = &JFactory::getUser();

				$sql = "SELECT count(*) FROM #__jcs_coupons_history WHERE `coupon_id` = '{$row->id}' AND user_id = ".$user->get('id');
				$db->setQuery($sql);
				$num = $db->loadResult();

				if($num >= $row->use_user)
				{
					$this->couponValid =  false;
					$this->couponError = 'You have used this coupon amount of times allowed';
				}
			}
		}

	}
	function create()
	{
		global $mainframe;
		$db = & JFactory::getDBO();

		$dispatcher =& JDispatcher::getInstance();
		JPluginHelper::importPlugin('payment');

		$order_id = JRequest::getVar('order_id');
		$order_id = explode('::', urldecode($order_id));
		$order_id = $order_id[0];
		$sql = "SELECT * FROM #__jcs_plans WHERE id = ".$order_id;
		$db->setQuery( $sql );
		$plan = $db->loadObject();
		$param = array_merge(JRequest::get('request'), array('params'=>$plan->params));

		$result = $dispatcher->trigger('onReceivePayment',array(& $param) );
		error_log("[** START Receive result]:  ".print_r($result, true)."\n\n", 3, JPATH_ROOT.DS.'logs'.DS.'jcs_log.txt');
		if(is_array($result))
		{
			error_log("[Receive result is array]:  \n\n", 3, JPATH_ROOT.DS.'logs'.DS.'jcs_log.txt');
			foreach ($result AS $res)
			{
				if(is_array($res))
				{
					error_log("[** Result array ]:  ".print_r($res, true)."\n\n", 3, JPATH_ROOT.DS.'logs'.DS.'jcs_log.txt');
					if(@isset($res['msg']))
					$mainframe->enqueueMessage($res['msg']);

					$model = $this->getModel('jcs');

					$order = explode('::', urldecode($res['sid']));
					$coupon_id = $order[1];
					$sid = $order[0];

					//print_r($res); exit;
					if(!$sid || !$res['gateway'] || !$res['gateway_id']
					|| !$res['user_id'] || !array_key_exists('price', $res) || !$res['pay'])
					{
						$link = JRoute::_('index.php?option=com_jcs&view=jcs&layout=form&Itemid='.(JCS_IID_PLANS != '' ? JCS_IID_PLANS : JRequest::getInt('Itemid')), false);
						error_log("[Not all passed]:  \n\n", 3, JPATH_ROOT.DS.'logs'.DS.'jcs_log.txt');
						$msg = JText::_('Not All Information is Passed to create subscription');
						//$mainframe->enqueueMessage('Not All Information is Passed to create subscription');
						//JError::raiseNotice('Not All Information is Passed to create subscription');
					}
					else
					{
						JRequest::setVar('data', $res);

						if ($model->store($res)) {
							error_log("[Model stored ]:  ".print_r($model, true)."\n\n", 3, JPATH_ROOT.DS.'logs'.DS.'jcs_log.txt');
							$msg = JText::_( 'Your Subscription Created Successfully' );
							if (!$model->published)
							$msg .= ' '.JText::_('But not activated automaticaly');

							// creating grant plans
							$model->grantPlans($res);

							$model->deactivatePlans($sid, $res);

							if($coupon_id && $coupon_id != '')
							{
								$sql = "UPDATE #__jcs_coupons_history SET subscription_id = '{$model->subscription_id}' WHERE id = '$coupon_id'";
								$db->setQuery($sql);
								$db->query();
							}

							JPluginHelper::importPlugin('system');
							$dispatcher->trigger('onAfterStoreSubscription',array( &$plan, &$model ) );

							jcsHelper::alertUser($res, $plan->alert_admin);
							$link = JRoute::_('index.php?option=com_jcs&view=jcs&layout=history&plan='.$sid.'&Itemid='.(JCS_HISTORY != '' ? JCS_HISTORY : JRequest::getInt('Itemid')), false);
							$params = new JParameter($plan->params);
							if($params->get('redirect'))
							{
								$link = $params->get('redirect');
							}
							
							
							// AngelDesk Integration
							$ids = preg_replace("#[^0-9,]#iU", '', $params->get('ad_ids'));
							if(JCS_AD_ENABLE && JCS_AD_SECRET_WORD && $ids)
							{
								$user = JUser::getInstance($res['user_id']);
								$soap = new SoapClient('https://angeldeskws.com/v1/public/api/adws.wsdl');
								$ids = explode(',', $ids);
								
								$p = $params->get('ad_period');
								if($p)
								{
									
									$period = time() + ($p * 86400);
									
									if(substr($p, 0, 5) == 'date:')
									{
										$period = strtotime(preg_replace("#[^0-9\-\:\ ]#iU", '', str_replace('date:', '', $p)));
									}
								}
								else 
								{
									switch($plan->days_type)
									{
										case 'hours':
											$x = 3600;
											break;
										case 'days':
											$x = 1 * 86400;
											break;
										case 'weeks':
											$x = 7 * 86400;
											break;
										case 'months':
											$x = 30 * 86400;
											break;
										case 'years':
											$x = 365 * 86400;
											break;
									}
									$period = time() + ($plan->days * $x); 
								}
								
								foreach ($ids AS $id)
								{
									$key = md5($user->get('email').$id.'1'.$period.JCS_AD_SECRET_WORD);
									$result = json_decode(@$soap->paidAccessCallback($user->get('email'), $id, 1, $period, $key));
									if($result != 'Ok!')
									{
										//echo $result->error->message;
									}
								}
							}
							// end AngelDesk integration
							
						} else {
							error_log("[Model NOT stored ]:  ".print_r($model, true)."\n\n", 3, JPATH_ROOT.DS.'logs'.DS.'jcs_log.txt');
							$link = JRoute::_('index.php?option=com_jcs&view=jcs&layout=history&Itemid='.(JCS_HISTORY != '' ? JCS_HISTORY : JRequest::getInt('Itemid')), false);
							$msg = JText::_( $model->getError(0) );
						}

						//$mainframe->enqueueMessage($msg);
					}
					break;
				}
			}
		}
		else
		{
			error_log("[No result array received]:  ".print_r($model, true)."\n\n", 3, JPATH_ROOT.DS.'logs'.DS.'jcs_log.txt');
			$mainframe->enqueueMessage('No value found');
			$mainframe->redirect(JRoute::_('index.php?option=com_jcs&view=jcs&layout=history&Itemid='.(JCS_HISTORY != '' ? JCS_HISTORY : JRequest::getInt('Itemid')), false));
		}

		if($link) $mainframe->redirect($link, $msg);
		parent::display();
	}
	
	function angeldesk()
	{
		$email = JRequest::getVar('email');
		$id = JRequest::getVar('product_id');
		if(!$email || !$id)
		{
			exit('no data');
		}
		
		$db = JFactory::getDBO();
		
		
		$sql = "SELECT * FROM #__users WHERE MD5(email) = '$email'";
		$db->setQuery($sql);
		$user = $db->loadObject();
		
		if(!$user)
		{
			exit('no user');
		}
		
		$sql = "SELECT s.params, u.extime as expire, u.ctime
		          FROM #__jcs_user_subscr AS u 
		     LEFT JOIN #__jcs_plans AS s ON s.id = u.subscription_id 
		     LEFT JOIN #__jcs_history AS h ON h.subscription_id = s.id 
		         WHERE u.user_id = {$user->id}
                   AND u.extime > NOW()
                   AND u.ctime < NOW()
                   AND u.published = 1
                 ORDER BY u.extime DESC";
		
		$db->setQuery($sql);
		$plans = $db->loadObjectList();
		
		$vip = 0;
		
		$sql = "SELECT NOW()";
		$db->setQuery($sql);
		$time[] = $db->loadResult();
		
		
		settype($plans, 'array');
		foreach ($plans AS $plan)
		{
			$params = new JParameter($plan->params);
			$ids = preg_replace("#[^0-9,]#iU", '', $params->get('ad_ids'));
			
			if($ids)
			{
				$ids = explode(',', $ids);
			
				if(in_array($id, $ids))
				{
					$vip = 1;
					
					$period = $params->get('ad_period');
					if($period)
					{
						if(is_int($period))
						{
							$sql = "SELECT '{$plan->ctime}' + INTERVAL {$period} DAY";
							$db->setQuery($sql);
							$time[] = $db->loadResult();
						}
						elseif(substr($period, 0, 5) == 'date:')
						{
							$time[] = preg_replace("#[^0-9\-\:\ ]#iU", '', str_replace('date:', '', $period));
						}
					}
					else 
					{
						$time[] = $plan->expire;
					}
				}
			}
		}
		sort($time, SORT_STRING);
		$time = $time[count($time) - 1];
		echo "{$vip}^{$time}";
		exit;
	}
	
	/*
	 function createCoupon()
	 {
	 global $mainframe;
	 $row =& JTable::getInstance('subscr', 'Table');
	 $row->value = '';
	 $row->discount = '';
	 $row->discount_type = 'sum';
	 $row->use_user = 0;
	 $row->use_num = 1;

	 // Make sure the web link table is valid
	 if (!$row->check()) {
	 $this->setError($this->_db->getErrorMsg());
	 return false;
	 }


	 // Store the web link table to the database
	 if (!$row->store()) {
	 if($return_fail = JRequest::getVar('return_fail'))
	 {
	 $mainframe->redirect(base64_decode($return_fail));
	 }
	 }
	 if($return_success = JRequest::getVar('return_success'))
	 {
	 $mainframe->redirect(base64_decode($return_success));
	 }

	 }*/
}
?>
