<?php
/**
 * $Id: view.html.php 8493 2012-06-15 10:54:43Z alfiya $
 * $LastChangedDate: 2012-06-15 16:54:43 +0600 (Fri, 15 Jun 2012) $
 * $LastChangedBy: alfiya $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');

jimport( 'joomla.application.component.view');
class JcsViewJcs extends JView
{
	function display($tpl = null)
	{

		global $mainframe;

		$layout = $this->getLayout();
		$model  = & $this->getModel('jcs');
		$user   = & JFactory::getUser();
		$Itemid = JRequest::getInt('Itemid');
		$pathway	     = & $mainframe->getPathway();

		$menus	= &JSite::getMenu();
		$menu	= $menus->setActive($Itemid);
		$menu	= $menus->getActive();
		$menu_params = new JParameter( $menu->params );

		// because the application sets a default page title, we need to get it
		// right from the menu item itself
		$params = $menu_params;
		//$params = &$mainframe->getParams();
		$document	= &JFactory::getDocument();

		if($meta_key = $menu_params->get('meta_key'))
		$document->setMetaData('keywords', $meta_key);


		if($meta_desc = $menu_params->get('meta_desc'))
		$document->setMetaData('description', $meta_desc);


		$document->addScript(JURI::root()."components/com_jcs/includes/shadowbox/build/adapter/shadowbox-base.js");
		$document->addScript(JURI::root()."components/com_jcs/includes/shadowbox/build/shadowbox.js");

		if($layout == 'history' )
		{
			$data = JRequest::getVar('data');
			//print_r($data);
			//$document->addScript(JURI::root()."components/com_jcs/includes/highslide/highslide-with-html.js");
			//$document->addStyleSheet(JURI::root()."components/com_jcs/includes/highslide/highslide1.css");
			$oid = JRequest::getInt('order_id');

			if($oid) $text = $model->getSubscriptionText($oid);

			if(!$user->get('id'))
			{
				$mainframe->redirect('index.php?option=com_jcs&view=jcs&layout=form&Itemid='.$Itemid);
				return;
			}
			if(JRequest::getInt('plan'))
			{
				$text = $model->getSubscriptionText(JRequest::getInt('plan'));
			}


			if( JRequest::getCmd( 'client', 'core' ) == 'core' ){
				if (is_object($menu) && $menu_params->get('show_page_title', 0))
				{
					$menu_params->set('page_title',	$menu_params->get('page_title', JText::_( 'Subscription History' ) ) );
					$pathway->addItem( JText::_("Subscription History") );
				}
				else
				{
					$menu_params->set('page_title',	JText::_( 'Subscription History' ));
					$pathway->addItem( JText::_("Subscription History") );
				}
			}
			$catids = false;
			if($catid = JRequest::getInt('catid'))
			{
				if($catid > 0)
				$catids = $catid;
			}
			else
			{
				$catids = $params->get("show_catid");
				if(is_array($catids)) $catids = implode(",", $catids);
				$show_whole_history = ($catids != '') ? $params->get("show_link", 1) : 0;
			}
			$items = $model->getHistory($catids);

			foreach($items as $k=>$item)
			{
				$params = new JParameter( $item->params );
				if($item->gateway == 'paypaypal' && $item->published==1)
				{
					$recurring = $params->get( 'paypaypal_requre' );
					if($recurring == 1)
					{
						$items[$k]->paypal_email = $params->get( 'paypaypal_email' );
					}

				}
				$items[$k]->muaccess = ($item->published && !$item->parent && $item->active ) ? $params->get( 'muaccess', 0 ) : 0;
				$items[$k]->coupon_info = $model->getSubscriptionCouponInfo($item->sid);
			}
			//$this->assignRef('params', $params);
			$this->assignRef('items', $items);
			$this->assignRef('text', $text);
			$this->assignRef('show_whole_history', $show_whole_history);

		}

		if($layout == 'form' )
		{
			$id = JRequest::getVar('id', 0);
			$menu_plans = $params->get("plans");
			$show_total = $params->get("show_link", 1);
			$template = $params->get('form_tmpl', 'standard');
			$list_view = $params->get('list_view', 'vert');
			$col_num = $params->get('horiz_num', '3');

			if($id == 0 && ($menu_plans > 0))
			{
				settype($menu_plans, "array");
				$id = implode(",", $menu_plans);
			}
			if($id && strpos($id, ","))
			{
				$id = explode(",",$id);
				JArrayHelper::toInteger($id);
			}

			$items = $model->getPlans($id);
			$plans = $model->getUserPlans();
			$coupons = $model->getCouponsNumber();

			$plansAct = $model->getUserActivePlans();

			$items = $this->getItems($items);

			$total = $model->getTotalPlans();

			$processors = $model->getProcessors();

			if (is_object($menu) && $menu_params->get('show_page_title', 0))
			{
				$menu_params->set('page_title',	$menu_params->get('page_title', JText::_( 'Subscription Plans' ) ) );
				$pathway->addItem( JText::_("Subscription Plans") );
			}
			else
			{
				$menu_params->set('page_title',	JText::_( 'Subscription Plans' ));
				$pathway->addItem( JText::_("Subscription Plans") );
			}
			$user_subscr = $model->getHistory(0);
			$user_subscr_plans = $model->getUserSubscriptionPlans($user->id);
if($template == 'custom')
$tpl = 'buttons';
			$this->assignRef('text', $text);
			$this->assignRef('user', $user);
			$this->assignRef('pay', $processors);
			$this->assignRef('items', $items);
			$this->assignRef('plans', $plans);
			$this->assignRef('total', $total);
			$this->assignRef('coupons', $coupons);
			$this->assignRef('show_total', $show_total);
			$this->assignRef('user_subscr', $user_subscr);
			$this->assignRef('template', $template);
			$this->assignRef('list_view', $list_view);
			$this->assignRef('col_num', $col_num);
			$this->assignRef('user_subscr_plans', $user_subscr_plans);
		}

		if($layout == 'muaccess')
		{
			$sid = JRequest::getInt('subscr_id');
			if( JRequest::getCmd( 'client', 'core' ) == 'core' ){
				if (is_object($menu) && $menu_params->get('show_page_title', 0))
				{
					$menu_params->set('page_title',	JText::_( 'Subscription Multi User Access' ));
					$pathway->addItem( JText::_("Subscription Multi User Access") );
				}
				else
				{
					$menu_params->set('page_title',	JText::_( 'Subscription Multi User Access' ));
					$pathway->addItem( JText::_("Subscription Multi User Access") );
				}
			}
			if(!$sid){
				JError::raiseWarning(500, 'ERROR The subscription is not selected' );
					
			}

			$item = $model->getUserSubscrInfo($sid, $user);

			$mua_param = new JParameter($item->params);
			$mua = $model->getSubscrMUA($sid);

			$allowed = $mua_param->get('muaccess');
			$show_inbox_link = false;
			if($allowed && $allowed  > count($mua))
			{
				$code = md5($user->id . $item->plan_id . $sid . $item->ctime);
				$code = substr( $code , 0 , 10);
					
				$mua_coupon = 'MUA-' . $sid . '-' . strtoupper($code);
				$instruction = str_replace("[MUA_COUPON]", '<br><span style="font-size: 120%; margin-left: 40px;"><b>'.$mua_coupon.'</b></span><br>', JText::_("LAYOUT_MUA_INSTRUCTIONS"));
				$number = (count($mua) > 0) ? count($mua) : JText::_('None');
				$instruction = str_replace("[USERNUMBER]", $number, $instruction);

				$instruction = str_replace("[ALLOWEDNUMBER]", $allowed, $instruction);
				$show_inbox_link = true;
					
			}
			else if (count($mua) > 0)
			{
				$instruction = JText::_("LAYOUT_MUA_LIMIT_ALERT");
			}
			else
			{
				$error = JText::_("This subscription doesn't have multi user access");
			}


			if(!$item->active || !$item->ifex)
			{
				$instruction = '';
				$error = JText::_("The subscription has expired");
			}

			$is_jsinbox_exist = is_dir(JPATH_ROOT.DS.'components'.DS.'com_jsinbox');
			if( $is_jsinbox_exist && $show_inbox_link){
				$inbox_url = JURI::root()."index.php?option=com_jsinbox&view=compose&type_id=".$mua_param->get('mua_msg_type')."&Itemid=".JRequest::getInt("Itemid");
				$inbox_url .= "&subject=".JText::_("Subscription multi user access");
				$inbox_body = JText::_("MUA_INBOX_MSG");
				$inbox_body = str_replace("[MUA_COUPON]", '<b>'.$mua_coupon.'</b>', $inbox_body);
				$inbox_body = str_replace("[SUBSCR_NAME]", $item->name, $inbox_body);
				$inbox_url .= "&body=".$inbox_body;
				$uri = JFactory::getURI();
				$inbox_url .= "&return=".base64_encode( $uri->toString());
			}



			$this->assignRef('params', $params);
			$this->assignRef('item', $item);
			$this->assignRef('instruction', $instruction);
			$this->assignRef('mua', $mua);
			$this->assignRef('error', $error);
			$this->assignRef('inbox_url', $inbox_url);
		}

		if($layout == 'gateways')
		{

			$menu_plans = $params->get("plans");
			$show_total = $params->get("show_link", 1);
			$template = $params->get('form_tmpl', 'standard');
			$pathway->addItem( JText::_("Gateways") );
			$sid = JRequest::getInt('subscr_id', 0);
			if(!$sid)
			{
				$mainframe->redirect(JRoute::_('index.php?option=com_jcs&view=jcs&layout=form&Itemid='.JRequest::getInt('Itemid'), false),
				JText::_('Subscription is not selected'), 'Error');
					
			}
			if(!$user->id)
			{
				$mainframe->redirect(JRoute::_('index.php?option=com_jcs&view=jcs&layout=form&subscr_id='.$sid.'&Itemid='.JRequest::getInt('Itemid'), false));
			}


			$plan = $model->getPlans($sid);
			$processors = $model->getProcessors();
			$coupons = $model->getCouponsNumber();

			$this->assignRef('user', $user);
			$this->assignRef('pay', $processors);
			$this->assignRef('plan', $plan[0]);
			$this->assignRef('coupons', $coupons);
		}


		$document->setTitle( $menu_params->get( 'page_title' ) );
		parent::display($tpl);
	}

	function _formLogin($tpl, $return = false)
	{
		$menu =& JSite::getMenu();
		$item = $menu->getActive();
		$sess = & JFactory::getSession();
		$Itemid = JRequest::getInt('Itemid');

		if($item)
		$params	=& $menu->getParams($item->id);
		else
		$params	=& $menu->getParams(null);
		if (!$url = JRequest::getVar('return', '', 'method', 'base64')) {
			$url = base64_encode($params->get('login', $sess->get('jcs_access_url')));
		}
		if(!$url)
		{
			$url = base64_encode(JRoute::_(JURI::root().'index.php?option=com_jcs&view=jcs&layout=history&Itemid='.$Itemid));
		}
		if($return == 'select')
		$url = base64_encode(JRoute::_(JURI::root().'index.php?option=com_jcs&view=jcs&layout=gateways&subscr_id='.JRequest::getInt('subscr_id').'&Itemid='.$Itemid));

		$this->assignRef('url', $url);
		parent::display($tpl);

	}

	function _planList($tpl)
	{
		$model  = & $this->getModel('jcs');
		$items = $model->getPlans();
		$items = $this->getItems($items);
		$this->assignRef('items', $items);
		parent::display($tpl);
	}

	function _processorList($tpl, $id)
	{
		$model  = & $this->getModel('jcs');
		$processors = $model->getProcessors();
		$this->assignRef('pay', $processors);
		$this->assignRef('id', $id);
		parent::display($tpl);
	}

	function getItems($items)
	{
		$model  = & $this->getModel('jcs');
		foreach($items as $k => $val)
		{
			$params = new JParameter( $val->params );
			$items[$k]->subscr_left = '';
			$items[$k]->available = true;
			if($purchase_limit = $params->get('purchase_limit'))
			{
				$subscr = $model->getActiveSubscriptions($val->id);
				settype($purchase_limit, 'int');
				if( ($purchase_limit - $subscr) <= 0)
				{
					$items[$k]->available = false;
				}
				else
				{
					$items[$k]->subscr_left = str_replace('[AMOUNT]', ($purchase_limit - $subscr), JText::_('SUBCRIPTIONS_AMOUNT_LEFT_ALERT'));
				}
			}
			$items[$k]->required = $req = $params->get('required', '');
			if($val->cross_plans != '' && $req != '')
			{
				$items[$k]->price = $model->calculatePrice($val->id, $val->cross_plans, $val->price, $val->params);

				$items[$k]->alert = $alert = $model->getAlert($val->id, $val->cross_plans, $val->params);

			}
			$items[$k]->show_grant = $show_grant =  $params->get('show_plans_grant');
			$items[$k]->plans_grant = '';
			if($show_grant)
			{
				$items[$k]->plans_grant = ($params->get('plans_grant') != '') ? $model->getPlansGrant($val->id, $params->get('plans_grant')) : '';
			}

			if($params->get('muaccess'))
			{
				$items[$k]->mua = JText::_("This subscription has multi user access");
			}
		}
		return $items;
	}


}

?>