<?php
/**
 * $Id: coupon.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
* @package JCommerce
*/

class TableCoupon extends JTable
{
    
	var $id = null;
	var $value = '';
	var $discount = 0;
	var $discount_type = 'procent';
	var $user_ids = '';
	var $strict = 0;
	var $ctime = null;
	var $extime = null;
	var $use_user = 0;
	var $use_num = 0;
	var $used_num = 0;
	var $trash = 0;
	var $checked_out = 0;
	var $checked_out_time = null;
	var $published = 1;
	var $plan_ids = '';
        
    function __construct( &$db ) {
        parent::__construct( '#__jcs_coupons', 'id', $db );
        $user   =& JFactory::getUser();
        if($this->ctime == NULL) $this->set( 'ctime', strftime('%Y-%m-%d %H:%M:%S', time()) );
    }
    
    function check()
    {
        if (trim($this->value) == '') {
            $this->_error = JText::_('Coupon have to contents value.');
            return false;
        }
        if (!floatval($this->discount)) {
            $this->_error = JText::_('Discount Amount have to be set.');
            return false;
        }
        if(!$this->id)
        {
			$db   =& JFactory::getDBO();
			$sql = "SELECT id FROM #__jcs_coupons WHERE `value` = '{$this->value}'";
			$db->setQuery($sql);
			if($db->loadResult())
			{
			    $this->_error = JText::_('Coupon Number already exists.');
			    return false;
			}
        }
        if($this->user_ids == JText::_('Any')) $this->user_ids = '';
        if($this->plan_ids == JText::_('Any')) $this->plan_ids = '';
		if($this->ctime == NULL || ($this->ctime == '0000-00-00 00:00:00')) $this->ctime = strftime('%Y-%m-%d %H:%M:%S', time());
        return true;    
    }

}
?>
