<?php
/**
 * $Id: jcs.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');
jimport('joomla.filter.input');

class TableJcs extends JTable
{

	var  $id          = NULL;
	var  $name        = '';
	var  $days        = 0;
	var  $days_type   = '';
	var  $price       = 0.00;
	var  $description = '';
	var  $published   = 1;
	var  $category    = '';
	var  $params      = '';
	var  $grant_reg   = 0;
	var  $grant_new   = 0;
	var  $granturl    = 0;
	var  $time_limit  = 0;
	var  $one_time    = 0;
	var  $alert_admin = 0;
	var  $component   = '';
	var  $adwords     = '';
	var  $ctime       = NULL;
	var  $discount    = 0.00;
	var  $invisible   = 0;
	var  $ordering    = 0;
	var  $catid       = 0;
	var  $finish_msg  = '';
	var  $gid         = 0;
	var  $usertype    = 'Registered';
	var  $data_fixed  = 0;
	var  $type_user   = 0;
	var  $type_article = 0;
	var  $type_category = 0;
	var  $type_component = 0;
	var  $checked_out = 0;
	var  $checked_out_time = 0;
	var  $contentcategory = '';
	var  $cross_plans = '';
	var  $alerts = '';
	var  $auto_child_plans = '';
	var  $invisible_in_history = 0;


	function __construct(& $db) {
		parent::__construct('#__jcs_plans', 'id', $db);
	}
	function bind($array, $ignore = '')
	{
		if (key_exists( 'params', $array ) && is_array( $array['params'] )) {
			$registry = new JRegistry();
			$registry->loadArray($array['params']);
			$array['params'] = $registry->toString();
		}
		if (key_exists( 'alerts', $array ) && is_array( $array['alerts'] )) {
			$registry = new JRegistry();
			$registry->loadArray($array['alerts']);
			$array['alerts'] = $registry->toString();
		}

		return parent::bind($array, $ignore);
	}

	/**
	 * Overloaded check method to ensure data integrity
	 *
	 * @access public
	 * @return boolean True on success
	 * @since 1.0
	 */
	function check()
	{
		if (trim($this->name) == '') {
			$this->_error = JText::_('Your Plan must contain a Name');
			return false;
		}

		jimport('joomla.filter.filteroutput');
		$alias = JFilterOutput::stringURLSafe($this->name);

		if(empty($this->alias) || $this->alias === $alias ) {
			//$this->alias = $alias;
		}
		return true;
	}
}
?>
