<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('restricted');

jimport( 'joomla.application.component.view');

class JcsViewCnf extends JView
{
  function display($tpl = null)
  {
    global $mainframe, $option;

    JToolBarHelper::title(   JText::_( 'Mighty Membership Extended Configuration' ));
    JToolBarHelper::save();
    JToolBarHelper::apply();
    JToolBarHelper::cancel( 'cancel', 'Close' );
	$bar = & JToolBar::getInstance('toolbar');
	$bar->addButtonPath(JPATH_COMPONENT_ADMINISTRATOR.DS.'library');
	$bar->appendButton( 'JSHelp',  'http://help.mightyextensions.com/member/configuration.htm', 1000, 500 );
		
    JHTML::_('behavior.tooltip');
    JHTML::_('behavior.switcher');

    $uri	=& JFactory::getURI();
    $ini = JFile::read( JPATH_COMPONENT.DS.'config.ini' );
    if ($ini=="")
    {
    	JError::raiseNotice(100,"Mighty Membership Notice: Please Fill in the fields and save the Configurations!");
    }

    $config_params = new JParameter( $ini, JPATH_COMPONENT.DS.'params.xml' );

    $this->assignRef( 'config_params', $config_params);
    $this->assignRef( 'request_url',	 $uri->toString());

    parent::display($tpl);
  }

  function renderParamsGroup( $group_name )
  {
    ?>
    <fieldset class="adminform">
		  <legend><?php echo JText::_( $group_name ); ?></legend>
		  <?php print $this->config_params->render('params',$group_name);?>
		</fieldset>
    <?php
  }
}
?>