<?php 
/**
 * $Id: view.html.php 7422 2011-11-02 04:34:33Z alfiya $
 * $LastChangedDate: 2011-11-02 10:34:33 +0600 (Wed, 02 Nov 2011) $
 * $LastChangedBy: alfiya $
 * MightyMembership by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

class JcsViewCoupon extends JView
{
    function display($tpl = null)
    {
        global $mainframe, $TB, $Itemid;
        $uri	=& JFactory::getURI();
        
        if($this->getLayout() == 'form')
        {
        	$this->_form($tpl);
        	return;
        }
          //echo      JRequest::getVar('filter_type');
        JToolBarHelper::title(   JText::_( 'Coupons' ), 'generic.png' );
        JToolBarHelper::publishList();
        JToolBarHelper::unpublishList();
        JToolBarHelper::deleteList();
        JToolBarHelper::editListX();
        JToolBarHelper::addNewX();
        $bar = & JToolBar::getInstance('toolbar');
		$bar->addButtonPath(JPATH_COMPONENT_ADMINISTRATOR.DS.'library');
		$bar->appendButton( 'JSHelp',  'http://help.mightyextensions.com/member/coupons.htm', 1000, 500 );
		
		
        JHTML::_('behavior.tooltip');
        JHTML::_('behavior.calendar');
        $db   =& JFactory::getDBO();
        $user =& JFactory::getUser();
        $option = JRequest::getVar('option', 'com_jcs');
        
        $filter_state		 = $mainframe->getUserStateFromRequest( $option.'coupons.filter_state',		'filter_state',		'',			'word' );
		$filter_type	     = $mainframe->getUserStateFromRequest( $option.'coupons.filter_type',		'filter_type',		'',			'string' );
		$filter_order        = $mainframe->getUserStateFromRequest( $option.'coupons.filter_order', 	'filter_order', 	'value' );
        $filter_order_Dir    = $mainframe->getUserStateFromRequest( $option.'coupons.filter_order_Dir',	'filter_order_Dir',	'ASC' );
        $limit               = $mainframe->getUserStateFromRequest( $option.'coupons.limit', 'limit',     $mainframe->getCfg('list_limit'), 0);
        $limitstart	         = JRequest::getVar('limitstart', 0, '', 'int');
        $search				 = $mainframe->getUserStateFromRequest( $option.'coupons.search',			'search',			'',			'string' );
		$search			     = JString::strtolower( $search );
        
       /* if($filter_order) $orderby 	= "\n ORDER BY $filter_order $filter_order_Dir";
        
        $query = "SELECT COUNT(*)"
            . "\n FROM #__jcs_coupons ";
            //. ($user->get('usertype') == 'Super Administrator' ? NULL : " AND seller_id = '".$user->get('id')."'")
            //;
    
        $db->setQuery( $query );
        $total = $db->loadResult();
        
        jimport('joomla.html.pagination');
        $pageNav = new JPagination( $total, $limitstart, $limit );
        
        $query = "SELECT c.*, "
            . "c.ctime AS `start`, "
            . "c.extime AS `finish`, "
            . "IF(c.extime < NOW(),1,0) AS expire, "
            . "IF(c.used_num >= c.use_num,1,0) AS usedout"
            . "\n FROM #__jcs_coupons AS c "
            //. ($user->get('usertype') == 'Super Administrator' ? 
            //    NULL : " AND seller_id = '".$user->get('id')."' " )
            . $orderby ;
            /*
             *   . "DATE_FORMAT(c.ctime, '%d, %b %Y') AS `start`, "
            . "DATE_FORMAT(c.extime, '%d, %b %Y') AS `finish`, "
            
        $db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
        //echo $db->_sql;
        $rows = $db->loadObjectList();*/
        
        $items      = & $this->get('Data','coupon');
		$total      = & $this->get('Total','coupon');
		$pagination = & $this->get('Pagination','coupon' );
        
        // table ordering
        $lists['order_Dir'] = $filter_order_Dir;
        $lists['order'] = $filter_order;
        
        $javascript 	= 'onchange="submitform();"';
        
        $opt = array();
		$opt[] = JHTML::_('select.option', 0, '- '.JText::_('Select coupon type').' -', 'id', 'title' );
		$opt[] = JHTML::_('select.option', 'procent', JText::_('Discount'), 'id', 'title' );
		$opt[] = JHTML::_('select.option', 'sum', JText::_('Gift certificate'), 'id', 'title' );
		$opt[] = JHTML::_('select.option', 'fixed', JText::_('Fixed sum'), 'id', 'title' );
		$lists['type'] = JHTML::_('select.genericlist', $opt, 'filter_type', 'class="inputbox" '.$javascript , 'id', 'title',  $filter_type);
		
		// state filter
		$lists['state']	= JHTML::_('grid.state',  $filter_state );       
        // search filter
		$lists['search']= $search;

        $this->assignRef('lists',	$lists);
        $this->assignRef('rows',	$items);
        $this->assignRef('pageNav',	$pagination);
        $this->assignRef('request_url',	$uri->toString());
        parent::display($tpl);
    }
    function _form($tpl = null)
    {
    	global $mainframe, $option;
        
        $db     =& JFactory::getDBO();
        $uri    =& JFactory::getURI();
        $user   =& JFactory::getUser();
        
        JHTML::_('behavior.tooltip');
        JHTML::_('behavior.calendar');
        
        $row = $this->get('Plan');
        
        $isNew = ($row->id < 1);
        
        $text = $isNew ? JText::_( 'New' ) : JText::_( 'Edit' );
        JToolBarHelper::title(   JText::_( 'Coupon' ).': <small><small>[ ' . $text.' ]</small></small>' );
        JToolBarHelper::save();
        JToolBarHelper::apply();
        if ($isNew)  {
              JToolBarHelper::cancel();
        } else {
         // for existing items the button is renamed `close`
            JToolBarHelper::cancel( 'cancel', 'Close' );
        }
        
        
        $lists['published']  = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $row->published );
        $types[] = JHTML::_('select.option', 'procent', "%, " . strtolower(JText::_( 'Discount' )) );
        $types[] = JHTML::_('select.option', 'sum', JCS_GENERAL_CURR.", ". strtolower(JText::_( 'Gift certificate' )));
        $types[] = JHTML::_('select.option', 'fixed', JCS_GENERAL_CURR.", ". strtolower(JText::_( 'Fixed sum' )));
        $lists['type'] = JHTML::_('select.genericlist', $types, 'discount_type', 'class="inputbox"', 'value', 'text', $row->discount_type );

        $lists['ctime'] = JHTML::_('calendar', $row->ctime ? $row->ctime : 'Never', 'ctime', 'ctime', '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox'));
        $lists['extime'] = JHTML::_('calendar', $row->extime ? $row->extime : 'Never', 'extime', 'extime', '%Y-%m-%d %H:%M:%S', array('class' => 'inputbox'));
        
        $this->assignRef('lists',	$lists);
        $this->assignRef('row',	$row);
        $this->assignRef('isNew',	$isNew);
    	parent::display($tpl);
    }
}
?>
